moGC_Factorys = {};
source(MultiOverlayV3.modDir.."scripte/module/gcfactorys/moGC_FactorysConfig.lua");

function moGC_Factorys:update(dt)
	if moModule.active.gcfactorys.isRunning then
		if moGC_Factorys.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateGC_Factorys"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moGC_Factorys.values.updateTimer, name="updateGC_Factorys", repeatable=1, ms=false, action=moGC_Factorys.load} ); 
		else
			moGC_Factorys:load();
		end;
	end;
end;

function moGC_Factorys:load()
	moGC_Factorys:loadFactorys();	
end;

function moGC_Factorys:loadFactorys()
	local playerFarmId = g_currentMission.player.farmId;	
	moGC_Factorys.values.factorys = {}; --new 
	if moModule.gc.factorys ~= nil and #moModule.gc.factorys > 0 then
		local deleteObject = {};
		for index=1, #moModule.gc.factorys do			
			if moModule.gc.factorys[index] ~= nil then
				local isObject = moModule:isObject(moModule.gc.factorys[index].object, true);
				if isObject then
					local gcfactory = moModule.gc.factorys[index].object;					
					if gcfactory.ownerFarmId == 0 or gcfactory.ownerFarmId == playerFarmId then
						local gcfactoryName = moModule.gc.factorys[index].xmlName;
						if moGC_Factorys.values.factorys[gcfactoryName] == nil then moGC_Factorys.values.factorys[gcfactoryName] = {};end;
						moGC_Factorys.values.factorys[gcfactoryName][#moGC_Factorys.values.factorys[gcfactoryName]+1] = {general={},output={},input={}};
						
						local lineTableGeneral = moGC_Factorys.values.factorys[gcfactoryName][#moGC_Factorys.values.factorys[gcfactoryName]].general;
						lineTableGeneral[#lineTableGeneral+1] = {};
						local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];						
						isLineTableGeneral.object = gcfactory;
						isLineTableGeneral.ownerFarmId = gcfactory.ownerFarmId or 0;
						isLineTableGeneral.objectName = moModule.gc.factorys[index].name;
						if moModule.gc.factorys[index].mohDisplayName ~= nil then isLineTableGeneral.objectName = moModule.gc.factorys[index].mohDisplayName;end;
						isLineTableGeneral.xmlName = gcfactoryName;						
						isLineTableGeneral.productivity = 0; 
						isLineTableGeneral.productivityName = moLanguageXml:getTxt("productivity", nil, g_i18n:getText("statistic_productivity"));
						isLineTableGeneral.productivityColor = 1;
						isLineTableGeneral.productivityActive = true;												
						local input = nil;
						local output = nil;
						if gcfactory.numOutputProducts > 0 then
							local lineTableOutput = moGC_Factorys.values.factorys[gcfactoryName][#moGC_Factorys.values.factorys[gcfactoryName]].output;
							output = lineTableOutput;
							for output=1, #gcfactory.outputProducts do
								lineTableOutput[#lineTableOutput+1] = {};
								local isLineTableOutput = lineTableOutput[#lineTableOutput];								
								local fillType = moFillTypes.values.fillTypes[gcfactory.outputProducts[output].fillTypeIndex];
								if fillType ~= nil then
									isLineTableOutput.fillTypeName = fillType.name;
									if fillType.regName:lower() == "chaff" or fillType.regName:lower() == "tree" or fillType.regName:lower() == "wood" or fillType.regName:lower() == "woodchips" then
										isLineTableOutput.fillTypeName = gcfactory.outputProducts[output].title;
									end;
								else
									isLineTableOutput.fillTypeName = gcfactory.outputProducts[output].title;
								end;							
								isLineTableOutput.fillTypesTotal = {gcfactory.outputProducts[output].fillTypeIndex};
								isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(gcfactory.outputProducts[output].fillLevel, 0));
								isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(gcfactory.outputProducts[output].capacity, 0));
								isLineTableOutput.percentageCapacity = math.floor(100 * (gcfactory.outputProducts[output].fillLevel/gcfactory.outputProducts[output].capacity));
								if gcfactory.outputProducts[output].objectSpawner ~= nil and gcfactory.outputProducts[output].objectSpawner.object ~= nil then
									local palFillLevel = Utils.getNoNil(gcfactory.outputProducts[output].objectSpawner.object.fillLevel, 0);
									local totalFullPal = Utils.getNoNil(gcfactory.outputProducts[output].fillLevel, 0)/palFillLevel;
									isLineTableOutput.palFull = string.format("%1.0f", "".. totalFullPal, 0);
								end;
							end;
						end;
						local totalFillLevel = 0;
						local totalCapacity = 0;
						if gcfactory.numInputProducts > 0 then
							local lineTableInput = moGC_Factorys.values.factorys[gcfactoryName][#moGC_Factorys.values.factorys[gcfactoryName]].input;
							input = lineTableInput;
							for input=1, #gcfactory.inputProducts do
								lineTableInput[#lineTableInput+1] = {};
								local isLineTableInput = lineTableInput[#lineTableInput];
								local capacity, fillLevel, fillTypesTotal = moGC_Factorys:getFillTypeLevels(gcfactory.inputProducts[input]);							
								local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];
								if fillType ~= nil then
									isLineTableInput.fillTypeName = fillType.name;
									if fillType.regName:lower() == "chaff" or fillType.regName:lower() == "tree" or fillType.regName:lower() == "wood" or fillType.regName:lower() == "woodchips" then
										isLineTableInput.fillTypeName = gcfactory.inputProducts[input].title;
									end;
								else
									isLineTableInput.fillTypeName = gcfactory.inputProducts[input].title;
								end;								
								isLineTableInput.fillTypesTotal = fillTypesTotal;
								isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
								isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
								isLineTableInput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
								totalFillLevel = totalFillLevel+Utils.getNoNil(fillLevel, 0);
								totalCapacity = totalCapacity+Utils.getNoNil(capacity, 0);
							end;
						end;
						isLineTableGeneral.productivityObject = moGC_Factorys:isProductivityObject(input, output); --or storage ! test !
						if isLineTableGeneral.productivityObject and totalCapacity > 0 and totalFillLevel > 0 then
							isLineTableGeneral.productivity = g_i18n:formatNumber(Utils.getNoNil(totalFillLevel/totalCapacity, 0)*100);
							isLineTableGeneral.productivityColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(totalFillLevel/totalCapacity, 0)*100, true}, "getProzentColor Productivity GC Factorys");
							if  gcfactory.productLines ~= nil and gcfactory.productLines[1] ~= nil then
								if not gcfactory.productLines[1].active then isLineTableGeneral.productivityActive = false;isLineTableGeneral.productivityColor = 4;end;
							end;
						end;						
					end;
				else					
					table.insert(deleteObject, index);
				end;
			end;
		end;
		test = false;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.gc.factorys, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;
end;

function moGC_Factorys:getFillTypeLevels(fillTypeModule)
	local fillLevelTotal = Utils.getNoNil(fillTypeModule.fillLevel, 0);
	local fillTypesTotal = {};
	local capacityTotal = Utils.getNoNil(fillTypeModule.capacity, 0);
	if fillTypeModule.fillTypes ~= nil and type(fillTypeModule.fillTypes) == "table" then
		for index, fillType in pairs(fillTypeModule.fillTypes) do
			--fillLevelTotal = fillLevelTotal+fillType.fillLevel;
			--capacityTotal = capacityTotal+fillType.capacity;
			table.insert(fillTypesTotal, index);
		end;
	end;
	return capacityTotal, fillLevelTotal, fillTypesTotal;
end;

function moGC_Factorys:isProductivityObject(input, output)
	if input == nil and output == nil then return false;end;
	if #input > 1 or #output > 1 or #input[1].fillTypesTotal > 1 or #output[1].fillTypesTotal > 1 then return true;end;	
	if #input[1].fillTypesTotal == 1 and #output[1].fillTypesTotal == 1 then
		local inputFillTypes = moFillTypes.values.fillTypes[input[1].fillTypesTotal[1]];
		local outputFillTypes = moFillTypes.values.fillTypes[output[1].fillTypesTotal[1]];
		if inputFillTypes ~= nil and outputFillTypes ~= nil then
			return inputFillTypes ~= outputFillTypes;
		end;
	end;
	return true;
end;
